%%% Programa para calcular los centros (centroides)

function [centrosnuevos] = calcentro(k,centros,XX,umbral)

% k = numero de centros
% centros = centroides anteriormente almacenados
% XX = vector de los datos nuevos a agrupar

% centrosnuevos = centroides calculados

N=length(XX);

distant=1300;
distn=301;          %LIMITE ES EL CRITERIO DE PARADA
LIMITE=abs(distant-distn); %%%%%%es una condicion para que, por lo menos, lo ejecute 1 vez
eps=100000;
centrosnuevos=centros;
while LIMITE<eps 

    
    centros=centrosnuevos;
    cont=zeros(1,k); %este vector lleva el numero de veces que un centro gana
    centrosnuevos=zeros(size(centros)); %defino un vector de centros 

    for t=1:N
  
        distancias=abs(centros-XX(t)); %%al usar complejos puedo calcular la distancia de un
        %%%patron a los centros de una tacada %%%%%%%%
        [a,ind]=min(distancias); %%%ind indica el centro que gana 
        I=ind;
        centrosnuevos(I)=centrosnuevos(I)+XX(t); %aado el vector x al centro mas cercano
        cont(I)=cont(I)+1;
    end
    centrosnuevos=centrosnuevos./cont;      %asi divido por el numero de veces que sumo los X
                                            %en definitiva, determino el centroide.
    distn=sum(abs(centros-centrosnuevos));  %esta instruccion determina lo que se han movido TODOS los centroides  
if 0
    escero=min(cont);
    if escero==0
        distn=100000;    %no hago nada 
    else
        centrosnuevos=centrosnuevos./cont;      %asi divido por el numero de veces que sumo los X
                                                %en definitiva, determino el centroide.
        distn=sum(abs(centros-centrosnuevos)); %esta instruccion determina lo que se han movido TODOS los centroides 
    end
end
    %eps=0.025*distant;
    %eps=0.05*distant;
    %eps=0.1*distant;
    %eps=0.15*distant;
    %eps=0.2*distant; %va bien asi
    %eps=0.25*distant;
    %eps=0.3*distant;
    %eps=0.35*distant;
    %eps=0.4*distant;
    eps=umbral*distant;   
    
    LIMITE=abs(distant-distn);
    distant=distn; 

end